<?php
 
 
 

namespace PhpWA\Protocol\Proto\Message;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class LocationMessage extends \Google\Protobuf\Internal\Message
{
    


    protected $degreesLatitude = null;
    


    protected $degreesLongitude = null;
    


    protected $name = null;
    


    protected $address = null;
    


    protected $url = null;
    


    protected $isLive = null;
    


    protected $accuracyInMeters = null;
    


    protected $speedInMps = null;
    


    protected $degreesClockwiseFromMagneticNorth = null;
    


    protected $comment = null;
    


    protected $jpegThumbnail = null;
    


    protected $contextInfo = null;

    



















    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getDegreesLatitude()
    {
        return isset($this->degreesLatitude) ? $this->degreesLatitude : 0.0;
    }

    public function hasDegreesLatitude()
    {
        return isset($this->degreesLatitude);
    }

    public function clearDegreesLatitude()
    {
        unset($this->degreesLatitude);
    }

    




    public function setDegreesLatitude($var)
    {
        GPBUtil::checkDouble($var);
        $this->degreesLatitude = $var;

        return $this;
    }

    



    public function getDegreesLongitude()
    {
        return isset($this->degreesLongitude) ? $this->degreesLongitude : 0.0;
    }

    public function hasDegreesLongitude()
    {
        return isset($this->degreesLongitude);
    }

    public function clearDegreesLongitude()
    {
        unset($this->degreesLongitude);
    }

    




    public function setDegreesLongitude($var)
    {
        GPBUtil::checkDouble($var);
        $this->degreesLongitude = $var;

        return $this;
    }

    



    public function getName()
    {
        return isset($this->name) ? $this->name : '';
    }

    public function hasName()
    {
        return isset($this->name);
    }

    public function clearName()
    {
        unset($this->name);
    }

    




    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    



    public function getAddress()
    {
        return isset($this->address) ? $this->address : '';
    }

    public function hasAddress()
    {
        return isset($this->address);
    }

    public function clearAddress()
    {
        unset($this->address);
    }

    




    public function setAddress($var)
    {
        GPBUtil::checkString($var, True);
        $this->address = $var;

        return $this;
    }

    



    public function getUrl()
    {
        return isset($this->url) ? $this->url : '';
    }

    public function hasUrl()
    {
        return isset($this->url);
    }

    public function clearUrl()
    {
        unset($this->url);
    }

    




    public function setUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->url = $var;

        return $this;
    }

    



    public function getIsLive()
    {
        return isset($this->isLive) ? $this->isLive : false;
    }

    public function hasIsLive()
    {
        return isset($this->isLive);
    }

    public function clearIsLive()
    {
        unset($this->isLive);
    }

    




    public function setIsLive($var)
    {
        GPBUtil::checkBool($var);
        $this->isLive = $var;

        return $this;
    }

    



    public function getAccuracyInMeters()
    {
        return isset($this->accuracyInMeters) ? $this->accuracyInMeters : 0;
    }

    public function hasAccuracyInMeters()
    {
        return isset($this->accuracyInMeters);
    }

    public function clearAccuracyInMeters()
    {
        unset($this->accuracyInMeters);
    }

    




    public function setAccuracyInMeters($var)
    {
        GPBUtil::checkUint32($var);
        $this->accuracyInMeters = $var;

        return $this;
    }

    



    public function getSpeedInMps()
    {
        return isset($this->speedInMps) ? $this->speedInMps : 0.0;
    }

    public function hasSpeedInMps()
    {
        return isset($this->speedInMps);
    }

    public function clearSpeedInMps()
    {
        unset($this->speedInMps);
    }

    




    public function setSpeedInMps($var)
    {
        GPBUtil::checkFloat($var);
        $this->speedInMps = $var;

        return $this;
    }

    



    public function getDegreesClockwiseFromMagneticNorth()
    {
        return isset($this->degreesClockwiseFromMagneticNorth) ? $this->degreesClockwiseFromMagneticNorth : 0;
    }

    public function hasDegreesClockwiseFromMagneticNorth()
    {
        return isset($this->degreesClockwiseFromMagneticNorth);
    }

    public function clearDegreesClockwiseFromMagneticNorth()
    {
        unset($this->degreesClockwiseFromMagneticNorth);
    }

    




    public function setDegreesClockwiseFromMagneticNorth($var)
    {
        GPBUtil::checkUint32($var);
        $this->degreesClockwiseFromMagneticNorth = $var;

        return $this;
    }

    



    public function getComment()
    {
        return isset($this->comment) ? $this->comment : '';
    }

    public function hasComment()
    {
        return isset($this->comment);
    }

    public function clearComment()
    {
        unset($this->comment);
    }

    




    public function setComment($var)
    {
        GPBUtil::checkString($var, True);
        $this->comment = $var;

        return $this;
    }

    



    public function getJpegThumbnail()
    {
        return isset($this->jpegThumbnail) ? $this->jpegThumbnail : '';
    }

    public function hasJpegThumbnail()
    {
        return isset($this->jpegThumbnail);
    }

    public function clearJpegThumbnail()
    {
        unset($this->jpegThumbnail);
    }

    




    public function setJpegThumbnail($var)
    {
        GPBUtil::checkString($var, False);
        $this->jpegThumbnail = $var;

        return $this;
    }

    



    public function getContextInfo()
    {
        return $this->contextInfo;
    }

    public function hasContextInfo()
    {
        return isset($this->contextInfo);
    }

    public function clearContextInfo()
    {
        unset($this->contextInfo);
    }

    




    public function setContextInfo($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\ContextInfo::class);
        $this->contextInfo = $var;

        return $this;
    }

}

